/**************************************************************************
 *	H E A D E R - F I L E :   D I G I I N F O . H                     *
 *  for DIGIINFO.C (New data-format)                                      *
 **************************************************************************/

/* Constants */

#define LinkDepth    80             /* max. Link-length */

#define PI           M_PI           /* You won't believe it */
#define WrongDist    20000          /* Offset, if something goes wrong */

#define MYLOC	     "JO60JM"       /* if INF won't match :-) */
#define MYMAXKM      30

/* type-conventions */

typedef char s9[10], s6[7], s2[3], s80[85], s8[9], s130[131];	

typedef struct  {                    /* what we need for digis */
                  s9      call;      /*  */
                  s6      qth;
                  unsigned char    typ;
                  long    info;
                } DIGI;

#define _DIGI   (char)1
#define _BOX    (char)2
#define _DX     (char)3
#define _TCPIP  (char)4
#define _WX     (char)5
#define _MF     (char)6
#define _SONST  (char)0
#define _NOK    (char)0
					
typedef struct  {                              /* .... and for links */
                 unsigned int	LinkStart;     /* so einiges                 */
                 unsigned int	LinkEnd;	
                 unsigned long	LinkBaud;
                 unsigned char	LinkStat;
                } LINK;
				
#define _OK     0
#define _INSTAB 1
#define _TEST	2
#define _PLAN	3
#define	_DEFEKT 4
#define _VUS    8
#define _DRAHT  16
#define _INSAT  32
#define _BUS    64
#define STATUS  7
#define TYP     120

						
#define LSize   ((int)sizeof(LINK))
#ifndef DSIZE
#define DSize	((int)sizeof(DIGI))
#endif

typedef struct 	{
		s80 zeile[38];
		} SPRACHE;

#define _DL_ 	0
#define _PA_	1
#define _F_	2
#define _G_	3
/* Czech language with character map ASCII-7bit */
#define _OK_	4
/* Czech language with character map ISO 8859-2 (aka ISO Latin2) */
#define _OK_L2_ 5
#define MAXSPR	6

				
