
#define		FALSE	0                    /* Oh, whats that ?! */
#define		TRUE	!FALSE
#define 	DSize	((int)sizeof(DIGI))  /* Size of a mysterious
					      * structure 		*/
#define		ERROR	-100		     /* An error has the value of
					      * -100 :-) 	*/
#define 	FINOTF		-101
#define 	NOMEM		-102

int kommatas[20], anzkomma;

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "digiinfo.h"

extern long AnzDigi;
extern DIGI *dliste;
/*
 * toupper for strings
 */
void strupr(char *s1) 
{
   while (*s1 != '\0') 
     {
	*s1=toupper(*s1);
	s1++;
     }
}

/*
 * extract a part of the string
 */	
char *mid(char *d,const char *s, int a, int l)
{	
	int i;

	strcpy(d,"");
	for(i=1; i<a; i++)
		s++;
	for(i=1; (i<=l) && (*s != '\0'); i++)
		*d++ = *s++;
	*d = (char)0x0;
	return d;
}

/*
 * Sucht angegebenen Digi in dliste und gibt den Index zurueck
 */

long SucheDigi(const char *DigiName)
{
   s9     call1;
   long   l=0,
   r=AnzDigi,
   x;
   int    result;
   strcpy(call1,DigiName);
   strupr(call1);
   
   while (r >= l)
     {
	
	x = (l+r)/2;
	result=strcmp(dliste[x].call,call1);
	if (result==0) return x;
	if (result>0) r=x-1; else l=x+1;
     }
   return ERROR;
}


/*
 * Count the commas in a string
 */
int CountCommas(char *str)
{
	int c,i;
	c = 1; 
	kommatas[0] = 0;
	for (i=0;i<strlen(str);i++)
		if (str[i] == ',') 
		{
			kommatas[c] = i+1;
			c += 1;
		}
	kommatas[c] = i+1;
	anzkomma = c-1;
	return anzkomma;
}


/*
 * Look for first occurence of a char 
*/
int strpos(char *str,char p)
{
   long	r;
   if((r = (long)strchr(str,p)) == 0) r= -1;
   else r= r-(long)(str) + 1l;
   return (int)r;
};

/*
 * remove n chars from the beginning of line
 */
char *entf(char *str, int n)
{
   int i = n;
   while (str[i] != '\0') 
     {
	str[i-n] = str[i];
	i += 1;
     }
   str[i-n] = '\0';
   return str;
}

/*
 * remove spaces from the beginning of a string
 */
char *entfsp(char *str)
{
 	int i = 0;
	if (strcmp(str,"") != 0)
	{
		while (str[i] == ' ') i += 1;
	    if (i > 0) entf(str,i);
	}
	return str;
}
	 
/*
 * reads max. 255 chars until EOL from FILE
 */
char *get(FILE *ausgabe, char *str)
{
   char *ptr;
   fgets(str,255,ausgabe);
   if (feof(ausgabe) == FALSE)		/* remove \n */
     {
	if ((ptr=strchr(str,'\n'))!= NULL) *ptr='\0';   /* remove \n */
	if ((ptr=strchr(str,'\r'))!= NULL) *ptr='\0';   /* and \r */
     }
   else str[0]='\0';
   return str;
}

/*
 * Extrcts information from a field
 */
char *ExtrFeld(char *d, char *s, int n, int len)
{
   char	str[255];
   int	i,ii;
   
   if (anzkomma >= n-1)
     {
	for (i = 0; i < (kommatas[n] - kommatas[n-1])-1; i++)
	  {
	     ii = kommatas[n-1]+i;
	     str[i] = s[ii];
	  }
	str[i] = '\0';
	i = 0;
	while (str[i] == ' ') i += 1;
	entf(str,i);
	i = strlen(str);
	while ((str[i-1] == ' ') && (i > 0)) i -= 1;
	if (i > 0) str[i] = '\0';
	if (strlen(str) > len) str[len-1] = '\0';
	/*		if (strcmp(str,"?") == 0) strcpy(str,""); */
	strcpy(d,str);
	return d;
     }
   return NULL;
}

/*
 * Makes a callsign of exactly 9 chars length
 */
char *MakeCall(char *s)
{
   strupr(s);
   strncat(s,"         ",(9 - strlen(s)));
   return s;
}

/*
 * copies s2 to s1 if s2 is not empty
 */
char *StrCopy(char *s1, const char *s2)
{
   if (strcmp(s2,"") != 0) strcpy(s1,s2);
   if (strpos(s1,'?') >= 0) strcpy(s1,"");
   return s1;
}
